Subject: Re: [PATCH 3/4] net: ethernet: cpsw: split out IRQ handler

From: Felipe Balbi <[email-masked]>
Date: Fri, 2 Jan 2015 21:02:38 -0600

Hi,

On Fri, Jan 02, 2015 at 02:56:36PM -0800, Dave Taht wrote:
> On Fri, Jan 2, 2015 at 11:03 AM, Felipe Balbi <[email-masked]> wrote:
> > Hi,
> >
> > (please use reply-all to keep mailing lists in Cc, also avoid
> > top-posting)
> 
> I am trying not to read netdev right now... and failing, obviously.

oops :-)

> > On Fri, Jan 02, 2015 at 10:58:29AM -0800, Dave Taht wrote:
> >> The beaglebone only has a 100mbit phy, so you aren't going to get more
> >> than that.
> >
> > very true :-) Still, with AM437x SK which is definitely GigE, I'm
> > getting 201Mbits/sec.
> >
> >> (so do a lot of IoT devices).
> >>
> >> So you have the two patches that went by on BQL and on NAPI for the beagle?
> >
> > no, got any pointers ?
> 
> the relevant thread was "am335x: cpsw: phy ignores max-speed setting"
> 
> and the initial very small BQL enablement patch was here:
> 
> https://patchwork.ozlabs.org/patch/407640/

I'll test it out, sure.

> (it needed a saner treatment of a failure to dma something in
> cpsw_tx_packet_submit  - the patch as is has also been part of nelsons
> trees for the beaglebone for a while)
> 
> But it was rightly pointed out later in the thread that this change
> 
> +#define CPSW_POLL_WEIGHT 16
> 
> made for the biggest part of the improvement, and someone else on the
> thread proposed handling that more dynamically for 100mbit phys with
> another patch (that I can't find at the moment)
> 
> ... but the root cause of the excessive latency in this driver was the
> single tx/rx dma queue, which you are addressing  in your patch set.

I still think there's a lot of work pending for CPSW, the think slows to
a crawl and takes a lot of CPU for something that should be mostly
handled by DMA. I can very easily get 85% CPU usage with iperf.

> So if you glop on more of the above, mo better, perhaps you will win
> bigger.
> 
> I will try to slice out some time to boot up a beagle on net-next next week.

my patches aren't applied yet, however.

cheers

-- 
balbi